# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# TODO: Add these buildreqs when available
#BuildRequires: perl(DateTime::Format::HTTP)
#BuildRequires: perl(DateTime::Format::Mail)
#BuildRequires: perl(DateTime::Format::IBeat)
#BuildRequires: perl(Test::Pod::LinkCheck)

Name:		perl-DateTime-Format-Builder
Epoch:		1
Version:	0.83
Release:	8.%{__distinit}%{__distvers}
Summary:	Create DateTime parser classes and objects
# examples/W3CDTF.pm:			GPL-1.0-or-later OR Artistic-1.0-Perl
# examples/MySQL.pm:			GPL-1.0-or-later OR Artistic-1.0-Perl
# lib/DateTime/Format/Builder.pm:	Artistic-2.0
# LICENSE:				Artistic-2.0 text
License:	Artistic-2.0 AND (GPL-1.0-or-later OR Artistic-1.0-Perl)
URL:		https://metacpan.org/release/DateTime-Format-Builder
Source0:	https://cpan.metacpan.org/modules/by-module/DateTime/DateTime-Format-Builder-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(DateTime) >= 1.00
BuildRequires:	perl(DateTime::Format::Strptime) >= 1.04
BuildRequires:	perl(Params::Validate) >= 0.72
BuildRequires:	perl(parent)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::More) >= 0.88
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(Devel::Cycle) >= 1.07
BuildRequires:	perl(Test::Memory::Cycle)
BuildRequires:	perl(Test::Pod) >= 1.00
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

# Filter out bogus dependencies from the examples
%global __requires_exclude perl\\(DateTime::Format::(HTTP|IBeat|Mail)\\)

%description
DateTime::Format::Builder creates DateTime parsers. Many string formats of
dates and times are simple and just require a basic regular expression to
extract the relevant information. Builder provides a simple way to do this
without writing reams of structural code.

Builder provides a number of methods, most of which you'll never need, or at
least rarely need. They're provided more for exposing of the module's innards
to any sub-classes, or for when you need to do something slightly beyond what
is expected.

%prep
%setup -q -n DateTime-Format-Builder-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CODE_OF_CONDUCT.md CONTRIBUTING.md README.md examples/
%{perl_vendorlib}/DateTime/
%{_mandir}/man3/DateTime::Format::Builder.3*
%{_mandir}/man3/DateTime::Format::Builder::Parser.3*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Dispatch.3*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Quick.3*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Regex.3*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Strptime.3*
%{_mandir}/man3/DateTime::Format::Builder::Parser::generic.3*
%{_mandir}/man3/DateTime::Format::Builder::Tutorial.3*

%changelog
* Sun Jan 15 2023 Paul Howarth <paul@city-fan.org> - 1:0.83-8
- Use SPDX-format license tag
- Assume we are building with rpm ≥ 4.9
- Use %%license unconditionally

* Mon Aug 10 2020 Paul Howarth <paul@city-fan.org> - 1:0.83-1
- Update to 0.83
  - Switched to GitHub issues

* Fri Nov  1 2019 Paul Howarth <paul@city-fan.org> - 1:0.82-2
- Fix License: tag to reflect content of actual shipped files, not just what
  the LICENSE file says (#1600504, CPAN RT#125832)

* Mon Mar  4 2019 Paul Howarth <paul@city-fan.org> - 1:0.82-1
- Update to 0.82
  - Removed use of Class::Factory::Util, which isn't really needed
- Package new upstream CODE_OF_CONDUCT.md and CONTRIBUTING.md
- Switch upstream from search.cpan.org to metacpan.org
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL releases prior to Fedora 13:
  - Drop legacy BuildRoot: and Group: tags
  - Drop explicit %%clean section
  - Drop explicit buildroot cleaning in %%install section
  - Drop support for building with Test::More < 0.88

* Tue Aug 16 2016 Paul Howarth <paul@city-fan.org> - 1:0.81-5
- BR: perl-generators where available
- Simplify find command using -delete
- Prefer %%global over %%define

* Tue Jun 30 2015 Paul Howarth <paul@city-fan.org> - 1:0.81-4
- Classify buildreqs by usage
- Code is full of tabs so avoid Test::NoTabs (how did it ever pass?)

* Tue Sep 16 2014 Paul Howarth <paul@city-fan.org> - 1:0.81-3
- Drop support for building with ExtUtils::MakeMaker < 6.30
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible
- BR: perl(Test::CPAN::Changes) unconditionally

* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> - 1:0.81-2
- Perl 5.18 rebuild

* Wed Apr  3 2013 Paul Howarth <paul@city-fan.org> - 1:0.81-1
- Update to 0.81
  - Fixes to pass tests with DateTime 1.00
  - Build with Dist::Zilla
  - Add various release tests
- License changed to Artistic 2.0
- Switch to ExtUtils::MakeMaker flow
- No longer need to explicitly require perl(Class::Factory::Util) and
  perl(DateTime::Format::Strptime)
- Bump version requirements for perl(Class::Factory::Util), perl(DateTime),
  perl(DateTime::Format::Strptime) and perl(Params::Validate)
- BR: perl(Test::CPAN::Changes), perl(Test::EOL) and perl(Test::NoTabs) for
  new release tests and explicitly run those tests
- Add patches to support building with old ExtUtils::MakeMaker and Test::More
  versions

* Fri Jul 13 2012 Paul Howarth <paul@city-fan.org> - 1:0.80-6
- Use Module::Build flow since we need Module::Build anyway
- Use a patch to fix character encodings rather than scripted iconv
- BR: perl(base), perl(Carp), perl(Devel::Cycle) ≥ 1.07, perl(lib) and
  perl(Scalar::Util)
- Drop redundant buildreq perl(Test::Signature)
- Drop support for old distributions prior to FC-3:
  - BR: perl(Test::Memory::Cycle) unconditionally
  - Don't need to define %%{perl_vendorlib)
  - Don't need to run test suite with LC_ALL=C

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> - 1:0.80-5
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Mar  4 2011 Paul Howarth <paul@city-fan.org> - 1:0.80-4
- BR: perl(Test::Memory::Cycle) where possible for additional test coverage
- Fix dependency filter for rpm 4.9.x
- Filter bogus provides of perl(main) on older distributions

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1:0.80-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 19 2010 Paul Howarth <paul@city-fan.org> - 1:0.80-2
- Fix dist tag for RHEL-6 Beta
- Recode README as UTF-8

* Sun Mar 14 2010 Paul Howarth <paul@city-fan.org> - 1:0.80-1
- Update to 0.80 (clean up tests)
- Bump epoch since upstream promises to stick to 2 digits after the decimal
  point from now on
- Signature test dropped, so no need to go to great lengths to pass it now

* Thu Feb  4 2010 Paul Howarth <paul@city-fan.org> - 0.7901-6
- Import from Fedora
- Tweak build process to pass signature test

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.7901-5
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7901-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7901-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Mar  4 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.7901-2
- Rebuild for new perl

* Sat Jan 26 2008 Chris Weyl <cweyl@alumni.drew.edu> - 0.7901-1
- Update to 0.7901
- Additional docs
- Some spec rework

* Thu Aug 31 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.7807-4
- Bump for mass rebuild

* Tue Aug 08 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.7807-3
- Bump for release & build, not in that order

* Tue Aug 08 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.7807-2
- Additional br's

* Fri Aug 04 2006 Chris Weyl <cweyl@alumni.drew.edu> - 0.7807-1
- Initial spec file for F-E
